#include "OSD50HD.h"

/* 	AUTHOR		https://osd.systems
** 	DATE 		17.12.2018
** 	VERSION		1.34.0
**
*/
void OSD50HD::ClrText(char iID)
{
  unsigned char b[10] = {0xFF, 0, 0x03, 0, 0, 0, 0, 0, 0, 0}; 
  b[1] = iID;
  SendFrame(b, 10);
}






void OSD50HD::SendText(char iID, unsigned char iX, unsigned char iY, char* str)
{
  unsigned char b[60] = {0xFF, 0x01, 0x04, 0x03, 0x14, 30, 0, 0, 0, 0}; //0
  b[1] = iID;
  b[3] = iX;
  b[4] = iY;
  //b[5]=30; //dlugosc
  int len = strlen(str);
  b[5] = len;

  int ptr = 10;
  for (int t = 0; t < len; t++)
    b[ptr++] = *str++;
  b[ptr++] = 0x03; //end of text
  SendFrame(b, ptr);
}

//Bitmap configuration
//This funcktion sets bitmap.
//X - position X,
//Y - position Y,
//LX - Sclae X,
//LY - Scale Y,
//dim -
void OSD50HD::SetBitmap(char iID, unsigned short X, unsigned short Y, byte LX, byte LY, byte dim, unsigned short styl, byte colour, byte object)
{
  unsigned char b[24] = {HEADER, 0, SETBITMAP, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  int cs = 0; //cheksum
  b[1] = iID;
  b[3] = cs;
  char*y = (char*)&styl;
  b[4] = y[1];

  b[5] = dim + (colour * 64);

  y = (char*)&Y; //polozenie Y
  b[6] = y[1];
  b[7] = y[0];
  y = (char*)&X; //polozenie X
  b[8] = y[1];
  b[9] = y[0];
  b[10] = LY;    //Skala Y
  b[11] = LX;    //Skala X
  b[14] = object;

  SendFrame(b, 19);
}

//This function loads and updates content of bitmap
void OSD50HD::UpdateBitmap(char iID, int NrBmp, int adrress, uint16_t DataCount, byte *data)
{
  unsigned char b[10] = {HEADER, 0, UPGRADEBITMAP, 0, 0, 0, 0, 0, 0, 0};
  int cs = 0;
  b[1] = iID;
  b[3] = cs; //
  adrress = 0;
  char*y = (char*)&adrress;
  b[4] = y[1];
  b[5] = y[0];
  y = (char*)&DataCount; //wyslanie dlugosci pliku
  b[6] = y[0];
  b[7] = y[1];
  b[8] = NrBmp; //numer bitmapy


  SendFrame(b, 9);
  // for (int t = 0; t < DataCount; t++)
  for (int t = 0; t < DataCount; t++)

    Serial.write(pgm_read_byte(&data[DataCount - t - 1]));
  //SendFrame(data, DataCount);
}
void OSD50HD::SendFrame(char *data, int count)
{
  for (int t = 0; t < count; t++)
    Serial.write(data[t]);

}
//This function draws horizontal or vertical line. Also dwars filled rectangles. 12 pcs object(12..23)
//X,Y - Position of top left corner.
//LX, LY - Lenght and wight of the object,
//colour - 0 - none, 1 - white, 2 - black
//Vsync - 1 - Waiting for vertical synchronization impulse before drawing. 
void OSD50HD::SendLineHV(char iID, unsigned short X, unsigned short Y, unsigned short LX, unsigned short LY, byte colour, byte Vsync, byte object)
{
  unsigned char b[24] = {HEADER, ID, LINEHV, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  int cs = 0; //cheksum
  b[1] = iID;
  b[3] = cs;
  b[4] = 0;
  b[5] = colour;

  char *y = (char*)&LY;
  b[6] = y[1];
  b[7] = y[0];
  y = (char*)&LX;
  b[8] = y[1];
  b[9] = y[0];
  y = (char*)&Y;
  b[10] = y[1];
  b[11] = y[0];
  y = (char*)&X;
  b[12] = y[1];
  b[13] = y[0];
  b[14] = object;
  b[15] = Vsync & 0x01;
  SendFrame(b, 19);
  if(Vsync)
    delay(40);
}
//This function draws a net
//X1, Y2 - Top left corner,
//X2, Y2 - Bottom right corner,
//LineWidth - Width of the line,
//DistanceX - The distance between the lines in the x axis,
//DistanceY - The distance between the lines in the y axis,
//colour - Colour of the line,
//object - number of object.
void OSD50HD::SendGrid(char iID, unsigned short X1, unsigned short Y1, unsigned short X2, unsigned short Y2, byte LineWidth, unsigned short DistanceX, unsigned short DistanceY, byte colour, byte object)
{
  unsigned char b[24] = {HEADER, ID, SETGRID, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  int cs = 0; //cheksum
  b[1] = iID;
  b[3] = cs;
  b[4] = colour;
  b[5] = LineWidth;
  char*y = (char*)&DistanceY;
  b[6] = y[1];
  b[7] = y[0];
  y = (char*)&DistanceX;
  b[8] = y[1];
  b[9] = y[0];
  y = (char*)&Y2;
  b[10] = y[1];
  b[11] = y[0];
  y = (char*)&X2;
  b[12] = y[1];
  b[13] = y[0];
  y = (char*)&Y1;
  b[14] = y[1];
  b[15] = y[0];
  y = (char*)&X1;
  b[16] = y[1];
  b[17] = y[0];
  b[18] = object;

  SendFrame(b, 19);
}
//This function sets plot.
//X , Y - Top left corner,
//LX - Lenght of the. LX * 16 = Number og pixels
//
//---------------------------------------------------------------------------
void OSD50HD::SetPlot(char iID,unsigned short X, unsigned short Y, byte LX, byte LY, byte styl, byte colour, byte object)
{ //funkcja sluzy do konfiguracji wykresu
  unsigned short XX;
  XX = X + 16 * LX;
  unsigned char b[24] = {HEADER, ID, SETWYKRES, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  int cs = 0; //cheksum
  b[1] = iID;
  b[3] = cs;
  b[4] = styl;
  b[5] = colour;
  b[6] = LY;
  b[7] = LX;
  char*y = (char*)&Y;
  b[8] = y[1];
  b[9] = y[0];
  y = (char*)&XX;
  b[10] = y[1];
  b[11] = y[0];
  b[12] = object;
  float param = 0 ;
  char *yy = (char*)&param;
  b[13] = yy[0];
  b[14] = yy[1];
  b[15] = yy[2];
  b[16] = yy[3];
  SendFrame(b, 19);
}
//This function updates a plot
//plot - number of plot. 0 or 1
//value - integer 0..255.
//---------------------------------------------------------------------------
void OSD50HD::UpdatePlot(char iID, byte plot, unsigned short value)
{ //funkcja sluzy do wpisywania dsanych do wykresu
  unsigned char b[10] = {HEADER, ID, WYKRES, 0, 0, 0, 0, 0, 0, 0,};
  int cs = 0; //cheksum
  b[1] = iID;
  b[3] = cs;
  b[4] = plot;//number of plot
  char*y = (char*)&value;
  b[5] = y[1];
  b[6] = y[0];

  SendFrame(b, 7);
}
//This function draws a circle
//X, Y - centre of circle
//width - width of line
//colour - 0 - none, 1 - white, 2 - black
//Vsync - 1 - Waiting for vertical synchronization impulse before drawing. 
//---------------------------------------------------------------------------
void OSD50HD::SendCircle(char iID, unsigned short X, unsigned short Y, unsigned short radixX, unsigned short radixY, unsigned short width, byte colour, byte Vsync, byte object)
{
  unsigned char b[24] = {HEADER, ID, CIRCLE, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  int cs = 0; //cheksum
  b[1] = iID;
  b[3] = cs;
  char*y = (char*)&width;
  b[4] = y[1];  // itab[1]
  b[5] = y[0];  // itab[2]

  y = (char*)&Y;
  b[6] = y[1];    // itab[3]
  b[7] = y[0];    // itab[4]
  y = (char*)&X;
  b[8] = y[1];   // itab[5]
  b[9] = y[0];   // itab[6]
  y = (char*)&radixY;
  b[10] = y[1];  // itab[7]
  b[11] = y[0];  // itab[8]
  y = (char*)&radixX;
  b[12] = 00; //y[1];    // itab[9]
  unsigned char t = 17; //odpowiada za eliptycznosc
  b[13] = t; //y[0];    // itab[10]
  b[14] = colour;

  b[15] = object;
  b[16] = Vsync & 0x01;
  b[17] = 0;
  b[18] = 0;

  SendFrame(b, 19);
  if(Vsync)
    delay(40);
}
//---------------------------------------------------------------------------
//This function draws a line
//X1, Y2 - Top left corner,
//X2, Y2 - Bottom right corner,
//LineWidth - Width of the line
//colour - 0 - none, 1 - white, 2 - black
//Vsync - 1 - Waiting for vertical synchronization impulse before drawing. 
void OSD50HD::SendLine(char iID, unsigned short X1, unsigned short Y1, unsigned short X2, unsigned short Y2, unsigned short LineWidth, byte colour, byte Vsync, byte object)
{
  unsigned char b[24] = {HEADER, ID, LINE, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  int cs = 0; //
  b[1] = iID;
  b[3] = cs;

  char*y = (char*)&LineWidth;
  b[4] = y[1];
  b[5] = y[0];

  y = (char*)&Y2;
  b[6] = y[1];
  b[7] = y[0];
  y = (char*)&X2;
  b[8] = y[1];
  b[9] = y[0];
  y = (char*)&Y1;
  b[10] = y[1];
  b[11] = y[0];
  y = (char*)&X1;
  b[12] = y[1];
  b[13] = y[0];
  b[14] = object;
  b[15] = colour;
  b[16] = Vsync & 0x01;
  b[17] = 0;
  b[18] = 0;
  SendFrame(b, 19);
  if (Vsync)
   delay(40);
  }
